// IToBService.aidl
package com.pvr.tobservice.interfaces;
import com.pvr.tobservice.enums.PBS_SystemInfoEnum;
import com.pvr.tobservice.enums.PBS_DeviceControlEnum;
import com.pvr.tobservice.enums.PBS_PackageControlEnum;
import com.pvr.tobservice.enums.PBS_PowerOnOffLogoEnum;
import com.pvr.tobservice.enums.PBS_HomeEventEnum;
import com.pvr.tobservice.enums.PBS_HomeFunctionEnum;
import com.pvr.tobservice.enums.PBS_SystemFunctionSwitchEnum;
import com.pvr.tobservice.enums.PBS_ScreenOffDelayTimeEnum;
import com.pvr.tobservice.enums.PBS_SleepDelayTimeEnum;
import com.pvr.tobservice.enums.PBS_SwitchEnum;
import com.pvr.tobservice.enums.PBS_USBConfigModeEnum;
import com.pvr.tobservice.enums.PBS_VideoPlayMode;
import com.pvr.tobservice.enums.PBS_WifiDisplayModel;
import com.pvr.tobservice.enums.PBS_StartVRSettingsEnum;
import com.pvr.tobservice.enums.PBS_ControllerKeyEnum;
import com.pvr.tobservice.enums.PBS_PICOCastUrlTypeEnum;
import com.pvr.tobservice.enums.PBS_PICOCastOptionOrStatusEnum;
import com.pvr.tobservice.enums.PBS_PICOCastOptionValueEnum;
import com.pvr.tobservice.enums.PBS_ControllerPairTimeEnum;
import com.pvr.tobservice.enums.PBS_ScreencastAudioOutputEnum;
import com.pvr.tobservice.enums.PBS_CustomizeSettingsTabEnum;
import android.os.CpuUsageInfo;

import com.pvr.tobservice.interfaces.IBoolCallback;
import com.pvr.tobservice.interfaces.ISensorCallback;
import com.pvr.tobservice.interfaces.ILongCallback;
import com.pvr.tobservice.interfaces.IIntCallback;
import com.pvr.tobservice.interfaces.IWDJsonCallback;
import com.pvr.tobservice.interfaces.IWDModelsCallback;
import com.pvr.tobservice.interfaces.IStringCallback;
import com.pvr.tobservice.interfaces.IBytesCallback;
import com.pvr.tobservice.interfaces.IGetControllerPairTimeCallback;
import android.view.Surface;
import android.media.AudioFormat;
import android.bluetooth.BluetoothDevice;


// Declare any non-default types here with import statements

interface IToBService {
    String pbsStateGetDeviceInfo(inout PBS_SystemInfoEnum type, int ext);
    void pbsControlSetDeviceAction(inout PBS_DeviceControlEnum deviceControlEnum,in IIntCallback callback);
    void pbsControlAPPManger(inout PBS_PackageControlEnum packageControlEnum, String path, int ext,in IIntCallback callback);
    void pbsControlSetPowerOffwithUSBCable(inout PBS_SwitchEnum  switchEnum, int ext);
    void pbsControlSetAutoConnectWIFI(String ssid, String pwd, int ext, in IBoolCallback callback);
    void pbsControlClearAutoConnectWIFI(IBoolCallback callback);
    void pbsPropertySetPowerOnOffLogo(inout PBS_PowerOnOffLogoEnum type, String path, int ext,in IBoolCallback callback);
    void pbsPropertySetHomeKey(inout PBS_HomeEventEnum event,inout PBS_HomeFunctionEnum function,in IBoolCallback callback);
    void pbsPropertySetHomeKeyAll(inout PBS_HomeEventEnum event,inout PBS_HomeFunctionEnum function, int timesetup, String pkg, String className, in IBoolCallback callback);
    void pbsPropertyDisablePowerKey(boolean isSingleTap, boolean enable, in IIntCallback callback);
    void pbsRemoveControllerHomeKey(inout PBS_HomeEventEnum eventEnum);
    void pbsPropertySetScreenOffDelay(inout PBS_ScreenOffDelayTimeEnum timeEnum, in IIntCallback callback);
    void pbsPropertySetSleepDelay(inout PBS_SleepDelayTimeEnum timeEnum);
    void pbsSwitchSystemFunction(inout PBS_SystemFunctionSwitchEnum systemFunction,inout PBS_SwitchEnum switchEnum, int ext);
    void pbsSwitchSetUsbConfigurationOption(inout PBS_USBConfigModeEnum uSBConfigModeEnum, int ext);
    void pbsAppSetAPPAsHome(String thirdPkg, String thirdClassName, int ext);
    void pbsPlayerOpenPlayer(String uri);
    void pbsPlayerSetPlayerMode(inout PBS_VideoPlayMode videoPlayMode);
    void pbsPlayerPrepare(String uri);
    void pbsPlayerStart(String uri);
    void pbsPlayerPause(String uri);
    void pbsPlayerContinuePlay(String uri);
    void pbsPlayerStopPlayer(String uri);
    void pbsPlayerGetDuration(String uri,in ILongCallback callback);
    void pbsPlayerGetCurProgress(String uri,in ILongCallback callback);
    void pbsPlayerSetSingleVideoLoop(in PBS_SwitchEnum singleVideoLoop);
    void pbsPlayerSetMultiVideoLoop(in PBS_SwitchEnum multiVideoLoop);
    void pbsPlayerSetMultiVideoList(String videoFolderPath, in IIntCallback callback);
    void pbsPlayerSetMultiVideoJump(boolean nextVideo);
    void pbsPlayerSeekVideo(long seekTime);
    void pbsPlayerGetCurPlayState(in IIntCallback callback);
    void pbsPlayerSetControlUI(in PBS_SwitchEnum showControlUI);
//    void pbsPlayerSetSensorReportMode(in PBS_SwitchEnum openSensorReport);
//    void pbsPlayerReportSensorData(in ISensorCallback callback);
    void pbsPlayerPlayCompleteFinishLauncher(in PBS_SwitchEnum backToLauncher);
    void pbsPlayerDeviceRecenter();

    void pbsScreenOn();
    void pbsScreenOff();
    void pbsAcquireWakeLock();
    void pbsReleaseWakeLock();
    void pbsWriteConfigFileToDataLocal(String path, String content, in IBoolCallback boolCallback);
    void pbsResetAllKeyToDefault(in IBoolCallback callback);
    void pbsEnableEnterKey();
    void pbsDisableEnterKey();
    void pbsEnableVolumeKey();
    void pbsDisableVolumeKey();
    void pbsEnableBackKey();
    void pbsDisableBackKey();

    void pbsAppSetAPPAsHomeTwo(in PBS_SwitchEnum open_guide, String packageName);

    /* start Add By Licky for 3821 add lock screen api */
    void pbsFreezeScreen(boolean lock);
    /* end Add By Licky for 3821 add lock screen api */

    /* start Add By Licky for 4218 add kill app api*/
    void pbsKillAppsByPidOrPackageName(in int[] pids, in String[] packageNames, int ext);
    /* end Add By Licky for 4218 add kill app api*/

    void pbsKillBackgroundAppsWithWhiteList(in String[] packageNames, int ext);

    /* statr Add By Licky for add Miracast api*/
    void pbsOpenMiracast();

    boolean pbsIsMiracastOn();

    void pbsCloseMiracast();

    void pbsStartScan();

    void pbsStopScan();

    void pbsSetWDModelsCallback(in IWDModelsCallback wdModelsCallback);

    void pbsSetWDJsonCallback(in IWDJsonCallback wdJsonCallback);

    void pbsConnectWifiDisplay(in PBS_WifiDisplayModel model);

    void pbsDisConnectWifiDisplay();

    void pbsForgetWifiDisplay(String address);

    void pbsRenameWifiDisplay(String address, String newName);

    void pbsUpdateWifiDisplays();

    PBS_WifiDisplayModel pbsGetConnectedWD();
    /* end Add By Licky for add Miracast api*/

    void pbsSwitchLargeSpaceScene(in IBoolCallback call, boolean open, int ext);
    void pbsGetSwitchLargeSpaceStatus(in IStringCallback callback, int ext);
    boolean pbsSaveLargeSpaceMaps(int ext);
    void pbsExportMaps(in IBoolCallback call, int ext);
    void pbsImportMaps(in IBoolCallback call, int ext);

    /*HardwarePropertiesManager */
    CpuUsageInfo[] pbsGetCpuUsages();
    float[] pbsGetDeviceTemperatures(int type,  int source);
//    float[] pbsGetFanSpeeds();

    /*capture*/
    void pbsCapture();

    /*record*/
    void pbsRecord();

    void pbsControlSetAutoConnectWIFIWithErrorCodeCallback(String ssid, String pwd, int ext, in IIntCallback callback);

    void pbsAppKeepAlive(String appPackageName, boolean keepAlive, int ext);

    void pbsTimingStartup(int year, int month, int day, int hour, int minute, boolean open);

    void pbsTimingShutdown(int year, int month, int day, int hour, int minute, boolean open);

    void pbsStartVrSettingsItem(in PBS_StartVRSettingsEnum vrSettingsEnum, boolean hideOtherItem, int ext);

    void pbsSwitchVolumeToHomeAndEnter(in PBS_SwitchEnum switchEnum, int ext);

    PBS_SwitchEnum pbsIsVolumeChangeToHomeAndEnter();

    int pbsSetControllerKeyState(in PBS_ControllerKeyEnum controllerKeyEnum, in PBS_SwitchEnum status, int ext);

    int pbsInstallOTAPackage(String otaPackagePath, int ext);

    void pbsStartRecordScreenBySurface(in Surface surface,int width, int height, int ext);

    void pbsStopRecordScreenBySurface(int ext);

    void pbsStartRecordAudio(in AudioFormat audioFormat, in IBytesCallback callback, int ext);

    void pbsStopRecordAudio(int ext);

    void pbsRemoveBondBLEDevice(in BluetoothDevice bluetoothDevice, int ext);

    void pbsBTDeviceSetPairingConfirmation(in BluetoothDevice bluetoothDevice,boolean confirm, int ext);

    void pbsGetSwitchSystemFunctionStatus(in PBS_SystemFunctionSwitchEnum systemFunction, in IIntCallback callback, int ext);

    String pbsSwitchGetUsbConfigurationOption(int ext);

    String pbsGetCurrentLauncher(int ext);

    PBS_ScreenOffDelayTimeEnum pbsPropertyGetScreenOffDelay(int ext);

    PBS_SleepDelayTimeEnum pbsPropertyGetSleepDelay(int ext);

    String pbsGetAutoConnectWiFiConfig(int ext);

    String pbsGetAutoMiracastConfig(int ext);

    String pbsGetTimingStartupStatus(int ext);

    String pbsGetTimingShutdownStatus(int ext);

    String pbsPropertyGetPowerKeyStatus(int ext);

    int pbsGetEnterKeyStatus(int ext);

    int pbsGetVolumeKeyStatus(int ext);

    int pbsGetBackKeyStatus(int ext);

    String pbsPropertyGetHomKeyStatus(in PBS_HomeEventEnum event, int ext);

    int pbsGetControllerKeyState(in PBS_ControllerKeyEnum controllerKeyEnum, int ext);

    PBS_SwitchEnum pbsControlGetPowerOffWithUSBCable(int ext);

    int pbsPicoCastInit(in IIntCallback callback, int ext);

    int pbsPicoCastSetShowAuthorization(int authZ, int ext);

    int pbsPicoCastGetShowAuthorization(int ext);

    String pbsPicoCastGetUrl(in PBS_PICOCastUrlTypeEnum urlType, int ext);

    int pbsPicoCastStopCast( int ext);

    int pbsPicoCastSetOption(in PBS_PICOCastOptionOrStatusEnum option, in PBS_PICOCastOptionValueEnum value, int ext);

    PBS_PICOCastOptionValueEnum pbsPicoCastGetOptionOrStatus(in PBS_PICOCastOptionOrStatusEnum castEnum, int ext);

    void pbsSetControllerPairTime(in PBS_ControllerPairTimeEnum timeEnum, IIntCallback callback, int ext);

    void pbsGetControllerPairTime(IGetControllerPairTimeCallback pairTimeCallback, int ext);

    int pbsSetSystemLanguage(String language, int ext);

    String pbsGetSystemLanguage(int ext);

    int pbsConfigWifi(String ssid,String pwd, int ext);

    String[] pbsGetConfiguredWifi(int ext);

    int pbsSetSystemCountryCode(in String countryCode, in IIntCallback callback, int ext);

    String pbsGetSystemCountryCode( int ext);

    int pbsSetSkipInitSettingPage(int flag, int ext);

    int pbsGetSkipInitSettingPage(int ext);

    int pbsIsInitSettingComplete(int ext);

    int pbsStartActivity(String packageName, String className, String action, String extra,in String[] categories,in int[] flags, int ext);

    int pbsCustomizeAppLibrary(in String[] packageNames, in PBS_SwitchEnum switchEnum, int ext);

    int[] pbsGetControllerBattery(int ext);

    int pbsGetControllerConnectState(int ext);

    String pbsGetAppLibraryHideList(int ext);

    int pbsSetScreenCastAudioOutput(in PBS_ScreencastAudioOutputEnum screencastAudionOutputEnum, int ext);

    PBS_ScreencastAudioOutputEnum pbsGetScreenCastAudioOutput(int ext);

    int pbsCustomizeSettingsTabStatus(in PBS_CustomizeSettingsTabEnum customizeSettingsTabEnum, in PBS_SwitchEnum switchEnum, int ext);

    PBS_SwitchEnum pbsGetCustomizeSettingsTabStatus(in PBS_CustomizeSettingsTabEnum customizeSettingsTabEnum, int ext);
}